EZSA-2020-001: Remote code execution in file uploads

Publication date:
03/03/2020 17:40

Severity:
High

Affected versions: ezsystems/ezpublish-kernel v7.5.6, v6.13.6, v5.4.14, and ezsystems/ezpublish-legacy v2019.03.4, v2017.12.7, v5.4.14
Resolving versions: ezsystems/ezpublish-kernel v7.5.6.2, v6.13.6.2, v5.4.14.1, and ezsystems/ezpublish-legacy v2019.03.4.2, v2017.12.7.2, v5.4.14.1

This Security Advisory is about a vulnerability in the way eZ Platform and eZ Publish Legacy handles file uploads, which can in the worst case lead to remote code execution (RCE), a very serious threat. An attacker would need access to uploading files to be able to exploit the vulnerability, so if you have strict controls on this and trust all who have this permission, you're not affected. On the basis of the tests we have made, we also believe the vulnerability cannot be exploited as long as our recommended vhost configuration is used. Here is the v2.5 recommendation for Nginx, as an example:
https://github.com/ezsystems/ezplatform/blob/2.5/doc/nginx/vhost.template#L31
 
This vhost template specifies that only the file app.php in the web root is executed, while vulnerable configurations allow execution of any php file. Apache is affected in the same way as Nginx, and is also protected by using the recommended configuration. The build-in webserver in PHP stays vulnerable, as it doesn't use this type of configuration (this webserver should only be used for development, never for production). We cannot be 100% certain our configuration is not vulnerable. We also do not know if all our users use the recommended configuration, so we send out this fix to be on the safe side.
 
The fix includes a blacklist feature for uploaded filenames, such as ".php". The file types on the blacklist cannot be uploaded. The blacklist is configurable. In eZ Platform you will find it as ezsettings.default.io.file_storage.file_type_blacklist in eZ/Bundle/EzPublishCoreBundle/Resources/config/default_settings.yml in vendors/ezsystems/ezpublish-kernel. In eZ Publish Legacy you will find it as FileExtensionBlackList in settings/file.ini. By default it blocks these file types: php, php3, phar, phpt, pht, phtml, pgif. The fix also inclues a new block against path traversal attacks, though this kind of attack was not reproducible in our tests.
 
This security update is distributed via Composer, see "Resolving versions" above.
 
This issue was reported to us by Maxime ROPELEWSKI. We are very grateful for their research, and responsible disclosure to us.


Have you found a security bug in eZ Publish or eZ Platform? See how to report it responsibly here: https://doc.ezplatform.com/en/latest/guide/reporting_issues/

All security advisories